#
# map3d4.rb
#
# $Id: map3d4.rb,v 1.1 2000/11/21 03:15:41 keiko Exp $
#

require "num/numarray"
require "num/dcl"

include Num::DCL
include Math


XMIN = -50
XMAX = 50
YMIN = -50
YMAX = 50
VXMIN = 0.0
VXMAX = 0.8
VYMIN = 0.0
VYMAX = 0.8
ZMIN = -50
ZMAX = 50
VZMIN = 0.0
VZMAX = 0.8
XVP3 = 2.5
YVP3 = -1.0
ZVP3 = 1.5
XFC3 = (VXMAX-VXMIN)/2
YFC3 = (VYMAX-VYMIN)/2
ZFC3 = (VZMAX-VZMIN)/2

NMAX = 40

def aplot(ijk)

  x = NumArray.new(Float, NMAX+1)
  y = NumArray.new(Float, NMAX+1)

  slpvpr(1)

  dt = 2.0*PI / NMAX
  for n in 0..NMAX
    x[n] = 40.0*sin(n*dt)
    y[n] = 40.0*cos(n*dt)
  end

  sgplu(NMAX+1, x, y)

  dt = 2.0*PI / 3
  for n in 0..3
    x[n] = 40.0*sin(n*dt)
    y[n] = 40.0*cos(n*dt)
  end

  sgplu(4, x, y)

  sgstxs(0.07)
  sgtxu(0.0, 0.0, 'DENNOU')
  cttl= format("%2.2d",ijk)
  sgtxu(0.0, -30.0, cttl)

end

#-- graph ---
iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; sgpwsn; gets)).to_i
sgopn iws

sgiset('IFONT', 2)

sgfrm

#-- X-Y PLANE ----
sgswnd(XMIN, XMAX, YMIN, YMAX)
sgsvpt(VXMIN, VXMAX, VYMIN, VYMAX)
sgstrn(1)
sgstrf

scspln(1, 2, VZMAX)
scseye(XVP3, YVP3, ZVP3)
scsobj(XFC3, YFC3, ZFC3)
scsprj

aplot(1)

#-- X-Z PLANE ----
sgswnd(XMIN, XMAX, ZMIN, ZMAX)
sgsvpt(VXMIN, VXMAX, VZMIN, VZMAX)
sgstrn(1)
sgstrf

scspln(1, 3, VYMIN)
scsprj

aplot(2)

#-- Y-Z PLANE ----
sgswnd(YMIN, YMAX, ZMIN, ZMAX)
sgsvpt(VYMIN, VYMAX, VZMIN, VZMAX)
sgstrn(1)
sgstrf

scspln(2, 3, VXMAX)
scsprj

aplot(3)

sgcls
